%Obtain a discrete, linear state-space representation
%By Jonas Magnussen (2011)
run init_values_2_linmod
run heating_system

x_work = [2.3e+004,3.5e+004,7.95e+004,64.75,144.0084 ...
    ,2.0e+006,32.358,2.0e+005,2.0e+005,2.0e+006,33.1,1.1410e+005 ...
    ,1.1410e+005,2.2683e+006,32.88,399.5486,694.8780]'; 
u = 50;
d = -5;
U = [u;d];

[sz_3rom_full,x_0_3rom_full,states_3rom_full] = obtain_linear_model;
[A_w, B_w, C_w, D_w] = linmod('obtain_linear_model', x_work, U);

[T1,X1,Y1] = sim('obtain_linear_model',[0 15000*60],[],'U');
[T2,X2,Y2] = sim('compare_simulink_model_vs_linear_model',[0 15000*60],[],'U');

Y_a = zeros(length(Y2(:,1,1)),1);
Y_b = zeros(length(Y2(:,1,1)),1);
Y_c = zeros(length(Y2(:,1,1)),1);
Y_v = zeros(length(Y2(:,1,1)),1);

for p = 1:length(Y2(:,1,1))
    Y_a(p) = Y2(p,1,1);
    Y_b(p) = Y2(p,2,1);
    Y_c(p) = Y2(p,3,1);
    Y_v(p) = Y2(p,4,1);
end

%Discretize
minute = 60;
lin_Ts = minute;
lin_sys = ss(A_w, B_w, C_w, D_w);
Wo = gram(lin_sys,'o');
rank_wo_lin = rank(Wo);

%For use in estimation
discrete_sys = c2d(lin_sys, lin_Ts);
Wo = gram(discrete_sys,'o');
rank_wo = rank(Wo);
A_kalman = discrete_sys.a;
B_kalman = discrete_sys.b;
C_kalman = discrete_sys.c;
D_kalman = discrete_sys.d;

B_d_u_kalman = B_kalman(:,1);
B_d_d_kalman = B_kalman(:,2);

%For use in mpc
mpc_Ts = 5*minute;
discrete_sys_5 = c2d(lin_sys, mpc_Ts);
Wo_mpc = gram(discrete_sys,'o');
rank_wo_mpc = rank(Wo_mpc);
A_d = discrete_sys_5.a;
B_d = discrete_sys_5.b;
C_d = discrete_sys_5.c;
D_d = discrete_sys_5.d;

B_d_u = B_d(:,1);
B_d_d = B_d(:,2);
