%Caulculate the Kalman-filter estimates
%By Jonas Magnussen (2011)
function kalman_estimate = optimal_estimate(vector)

persistent x_post_prev;
persistent P_post_prev;
persistent kalman_ran;
persistent runned_status;

second = vector(length(vector));
n = 17;
C_size = 4;
discretization_Ts = 60;

if second == 400*60
     test=1;
end 

x_0_3rom_full = [5.7951e+004;9.5195e+004;1.9467e+005;99.1279;164.0084;4.2683e+006;30;6.2819e+005;...
6.2819e+005;4.2683e+006;30;3.1410e+005;3.1410e+005;4.2683e+006;30;359.5486;594.8780];
x_init = x_0_3rom_full;
P_init = 10*eye(n);

sample = mod(floor(second/discretization_Ts), discretization_Ts);

x = mod(second, discretization_Ts);

if second == 0 && isempty(kalman_ran) == 1
    kalman_ran = 1;
    P_post_prev = P_init;
    x_post_prev = x_init;
    runned_status = 1;
    kalman_estimate = x_post_prev;
    return;
elseif x == 0 && sample ~= runned_status
    A_vec = vector(1:n*n, 1);
    B_vec = vector((n*n)+1:(n*n)+(n*2) , 1);
    C_vec = vector((n*n)+(n*2)+1:((n*n)+(n*2))+C_size*n, 1);
 
    process_tuning_min = [1000,2000,1000,0*10^1,6*10^4,200,1*10^6,3000,5000,1000,4*10^6,5000,2000,8000,6*10^6,0*10^2,6*10^7];

    measurement_tuning_min = [0.5,0.5,0.5,0.5];
    Q = diag(process_tuning_min);
    R = diag(measurement_tuning_min);
    
    u = vector(length(vector) - 2);
    d = vector(length(vector) - 1);
    u_kalman = [u;d];
    y = vector(((n*n)+(n*2))+(C_size*n)+1:(((n*n)+(n*2))+(C_size*n)+C_size), 1);
    
    A = vector2matrix(A_vec, n, n);
    B = vector2matrix(B_vec, n, 2);
    C = vector2matrix(C_vec, C_size, n);

    % iii
    P_apri = A*P_post_prev*A' + Q;
    K = P_apri*C'*inv(C*P_apri*C' + R);

    x_apri = A*x_post_prev + B*u_kalman;

    x_post = x_apri + K*(y - C*x_apri);

    P_post = (eye(n) - K*C)*P_apri*(eye(n) - K*C)' + K*R*K';
    
    kalman_estimate = x_post;

    P_post_prev = P_post; 
    x_post_prev = x_post;
    
    runned_status = sample;
else
    runned_status = sample;
    kalman_estimate = x_post_prev;
end 