%%% Solving a quadratic optimization problem
%By Jonas Magnussen (2011)
function optimizer_output = optimize(vectors)

persistent optimizer_output_prev;
persistent optimizer_counter;
persistent quadprog_runned_status;
persistent day_counter;

minute = 60;
hour = minute*minute;
seconds = vectors(length(vectors));
Cd_size = 4;
number_of_states = 17;

Ts = 5*minute;

H_p = 50;
H_u = 35;
day = 86400;

day_nr = floor(seconds/day);

    if seconds < day
        day_counter = 0;
        choose_constraint = 4800;
    elseif seconds >= day_nr*day
        day_counter = day_nr;
        choose_constraint = day_counter*day + 4800;
    end

sampleNUMBER = mod(floor(seconds/Ts), H_p*Ts);

x = mod(seconds, Ts);

choose_quadprog = mod(floor(seconds/hour), 24);

if seconds == 0 && isempty(optimizer_counter) == 1
    optimizer_counter = 0;
    quadprog_runned_status = 1;
end

if x == 0 && quadprog_runned_status ~= sampleNUMBER
    H_vec = vectors(1:(H_u*H_u), 1); 
    G_vec = vectors((((H_u*H_u)+1)):(((H_u*H_u))+H_u), 1);
    F_vec = vectors((((H_u*H_u)+H_u)+1):(((H_u*H_u))+H_u + (2*H_u*H_u)), 1);
    F_1_vec = vectors(((((H_u*H_u)+H_u)+ 2*H_u*H_u)+1):((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u)), 1);
    f_vec = vectors((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+1):(((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u)), 1);
    Gamma_vec = vectors((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u)) + 1:(((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size)), 1);
    g_vec_1 = vectors((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size))+1: (((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + H_p*Cd_size), 1);
    g_vec_2 = vectors((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + H_p*Cd_size)+1: (((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + (H_p*Cd_size)) + (H_p*Cd_size), 1);
    Theta_vec = vectors((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size)+1: ((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u), 1);
    Psi_vec = vectors(((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u) + 1:((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states), 1);
    Upsilon_vec = vectors(((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + 1:(((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p), 1);
    x_hat_vec = vectors((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p) + 1:((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p) + number_of_states), 1);
    C_d_vec = vectors((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p + number_of_states) + 1:((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p) + number_of_states + Cd_size*number_of_states), 1);
    F_F_vec = vectors((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p + number_of_states + Cd_size*number_of_states) + 1:((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p) + number_of_states + Cd_size*number_of_states + Cd_size*H_p), 1);
    W_vec = vectors((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p + number_of_states + Cd_size*number_of_states + Cd_size*H_p) + 1:((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p) + number_of_states + Cd_size*number_of_states + Cd_size*H_p + 2*H_u*H_u), 1);
    v_vec = vectors((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p + number_of_states + Cd_size*number_of_states + Cd_size*H_p + 2*H_u*H_u) + 1:((((((((H_u*H_u))+(H_u) + (2*H_u*H_u)) + (2*H_u))+(2*H_u) + (H_p*Cd_size*H_p*Cd_size) + 2*H_p*Cd_size) + Cd_size*H_p*H_u + Cd_size*H_p*number_of_states) + Cd_size*H_p) + number_of_states + Cd_size*number_of_states + Cd_size*H_p + 2*H_u*H_u + 2*H_u), 1);
    u_previous = vectors(length(vectors)-1);

    H = vector2matrix(H_vec, H_u, H_u)*2;
    G = G_vec;
    F = vector2matrix(F_vec, 2*H_u, H_u);
    C_d = vector2matrix(C_d_vec, Cd_size, number_of_states);
    W = vector2matrix(W_vec, 2*H_u, H_u);
    
    %Feedforward
    F_F = vector2matrix(F_F_vec, H_p*Cd_size, 1);
    
    Gamma = vector2matrix(Gamma_vec, H_p*Cd_size, H_p*Cd_size);
    Theta = vector2matrix(Theta_vec, H_p*Cd_size, H_u);
    Psi = vector2matrix(Psi_vec, Cd_size*H_p, number_of_states);
    
    f_quadprog = F_1_vec*u_previous + f_vec;
    
    y = C_d*x_hat_vec;
    
    if choose_quadprog < 12
    % Ad hoc y_hat        
        if seconds == day
            g = g_vec_2;
        elseif seconds < choose_constraint
           for m = 0:H_p-1
               g(m*Cd_size+1:m*Cd_size + Cd_size, 1) = y;
           end
        else
            g = g_vec_1;
        end
    elseif choose_quadprog >= 12
        g = g_vec_2;
    end
    
    gamma_quadprog = -1*Gamma*(Psi*x_hat_vec + Upsilon_vec*u_previous + F_F) - g;

    omega = [f_quadprog; gamma_quadprog; v_vec];
    
    F_1 = F;
    F_2 = Gamma*Theta;
    
    Omega = [F_1;F_2; W];

    options = optimset('MaxIter', 500);
     
    [x, ~, exitflag, ~, ~] = quadprog(H, G, Omega, omega,[], [], [], [], [], options); %den vanlige

    if exitflag == -2
        if seconds == 0
            optimizer_output = 0;
            optimizer_output_prev = optimizer_output;
            
            fprintf('This occured after %d seconds. \n Use u(0) \n', seconds)
        else
            fprintf('This occured after %d seconds. \n Use u(k-1) \n', seconds)
            if u_previous + x(1) > 80
                optimizer_output = 0;
%                 optimizer_output = optimizer_output_prev;
            elseif u_previous + x(1) < 35 
                optimizer_output = 0;
%                 optimizer_output = optimizer_output_prev;
            else
                optimizer_output = optimizer_output_prev;
            end
        end
    else
        optimizer_output = x(1);
        optimizer_output_prev = optimizer_output;
    end
    
    quadprog_runned_status = sampleNUMBER;
    optimizer_counter = 1;
else
    quadprog_runned_status = sampleNUMBER;
    optimizer_counter = 0;
    optimizer_output = optimizer_output_prev;   
end