%%Run the system with a conventional control scheme
%By Jonas Magnussen (2011)
clear all;
clc;
warning off;

run init_values
run heating_system
sim building_model_conventional

plot_theta_minute_conv = zeros(timeaxisplot_minute,1);
plot_theta_ref_conv = zeros(timeaxisplot_minute,1);
plot_theta_2A_minute = zeros(timeaxisplot_minute,1);
plot_theta_2B_minute = zeros(timeaxisplot_minute,1);
plot_theta_2C_minute = zeros(timeaxisplot_minute,1);
plot_theta_4A_minute = zeros(timeaxisplot_minute,1);
plot_theta_4B_minute = zeros(timeaxisplot_minute,1);
plot_theta_4C_minute = zeros(timeaxisplot_minute,1);
plot_theta_6_minute = zeros(timeaxisplot_minute,1);
plot_theta_7_minute = zeros(timeaxisplot_minute,1);
plot_q_rel_minute = zeros(timeaxisplot_minute,1);
plot_q_rel_dh_minute = zeros(timeaxisplot_minute,1);
plot_theta_return_minute = zeros(timeaxisplot_minute,1);

plot_used_energy_mvarmeveksler = zeros(timeaxisplot_minute,1);
plot_available_energy = zeros(timeaxisplot_minute,1);

plot_valve_t4A = zeros(timeaxisplot_minute,1);
plot_valve_t4B = zeros(timeaxisplot_minute,1);
plot_valve_t4C = zeros(timeaxisplot_minute,1);

%Disturbances
plot_w_people_A = zeros(timeaxisplot_minute,1);
plot_w_lights_A = zeros(timeaxisplot_minute,1);
plot_w_equip_A = zeros(timeaxisplot_minute,1);
plot_w_people_B = zeros(timeaxisplot_minute,1);
plot_w_lights_B = zeros(timeaxisplot_minute,1);
plot_w_equip_B = zeros(timeaxisplot_minute,1);
plot_w_people_C = zeros(timeaxisplot_minute,1);
plot_w_lights_C = zeros(timeaxisplot_minute,1);
plot_w_equip_C = zeros(timeaxisplot_minute,1);

for i = 0:length(plot_theta_2A_minute) - 1
    plot_theta_minute_conv(i+1) = theta(1+6*i);
    plot_theta_ref_conv(i+1) = theta_ref_conv(1+6*i);
    plot_theta_2A_minute(i+1) = theta_2A(1+6*i);
    plot_theta_2B_minute(i+1) = theta_2B(1+6*i);
    plot_theta_2C_minute(i+1) = theta_2C(1+6*i);
    plot_theta_4A_minute(i+1) = theta_4A(1+6*i);
    plot_theta_4B_minute(i+1) = theta_4B(1+6*i);
    plot_theta_4C_minute(i+1) = theta_4C(1+6*i);
    plot_theta_6_minute(i+1) = theta_6(1+6*i);
    plot_theta_7_minute(i+1) = theta_7(1+6*i);
    plot_q_rel_minute(i+1) = q_rel(1+6*i);
    plot_q_rel_dh_minute(i+1) = q_rel_dh(1+6*i);
    plot_theta_return_minute(i+1) = theta_return(1+6*i);
    
    %Energy
    plot_used_energy_mvarmeveksler(i+1) = (plot_theta_minute_conv(i+1) -  plot_theta_return_minute(i+1))*calculate_energy;
    plot_available_energy(i+1) = plot_theta_minute_conv(i+1)*calculate_energy;

    %Disturbances
    plot_w_people_A(i+1) = w_people_A(1+6*i);
    plot_w_equip_A(i+1) = w_equip_A(1+6*i);
    plot_w_lights_A(i+1) = w_lights_A(1+6*i);
    plot_w_people_B(i+1) = w_people_B(1+6*i);
    plot_w_equip_B(i+1) = w_equip_B(1+6*i);
    plot_w_lights_B(i+1) = w_lights_B(1+6*i);
    plot_w_people_C(i+1) = w_people_C(1+6*i);
    plot_w_equip_C(i+1) = w_equip_C(1+6*i);
    plot_w_lights_C(i+1) = w_lights_C(1+6*i);
    
    %Valve radiators
    plot_valve_t4A(i+1) = alpha_A(1 + 6*i,1);
    plot_valve_t4B(i+1) = alpha_B(1 + 6*i,1);
    plot_valve_t4C(i+1) = alpha_C(1 + 6*i,1);
end

%Indoor, radiator, water, ventilation and outdoor temperatures (Room A)
figure(1);
subplot(3,1,1), plot(t_minute, plot_theta_2A_minute);
axis([0 timeaxisplot_minute 16 22]);
xlabel('time [min]'), ylabel('\theta_{2A} [^\circC]');
subplot(3,1,2), plot(t_minute, plot_theta_4A_minute, t_minute, plot_theta_minute_conv);
legend('\theta_{4A}', '\theta');
axis([0 timeaxisplot_minute 17 85]);
xlabel('time [min]'), ylabel('temp [^\circC]');
subplot(3,1,3), plot(t_minute, plot_valve_t4A);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');
 
%Indoor, radiator, water, ventilation and outdoor temperatures (Room B)
figure(2);
subplot(3,1,1), plot(t_minute, plot_theta_2B_minute);
axis([0 timeaxisplot_minute 16 22]);
xlabel('time [min]'), ylabel('\theta_{2B} [^\circC]');
subplot(3,1,2), plot(t_minute, plot_theta_4B_minute, t_minute, plot_theta_minute_conv);
legend('\theta_{4B}', '\theta');
axis([0 timeaxisplot_minute 17 85]);
xlabel('time [min]'), ylabel('temp [^\circC]');
subplot(3,1,3), plot(t_minute, plot_valve_t4B);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');

%Indoor, radiator, water, ventilation and outdoor temperatures (Room C)
figure(3);
subplot(3,1,1), plot(t_minute, plot_theta_2C_minute);
axis([0 timeaxisplot_minute 16 22]);
xlabel('time [min]'), ylabel('\theta_{2C} [^\circC]');
subplot(3,1,2), plot(t_minute, plot_theta_4C_minute, t_minute, plot_theta_minute_conv);
legend('\theta_{4C}', '\theta');
axis([0 timeaxisplot_minute 17 85]);
xlabel('time [min]'), ylabel('temp [^\circC]');
subplot(3,1,3), plot(t_minute, plot_valve_t4C);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');
 
figure(4);
subplot(3,1,1), plot(t_minute, plot_theta_7_minute);
axis([0 timeaxisplot_minute 14 23]);
xlabel('time [min]'), ylabel('\theta_{7} [^\circC]');
subplot(3,1,2), plot(t_minute, plot_q_rel_minute);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');
subplot(3,1,3), plot(t_minute, plot_theta_6_minute);
axis([0 timeaxisplot_minute -8 0]);
xlabel('time [min]'), ylabel('\theta_{6} [^\circC]');


figure(6);
subplot(3,1,1),plot(t_minute, plot_theta_minute_conv, t_minute, plot_theta_return_minute);
legend('\theta','\theta_{fb}','Orientation', 'horizontal', 'Location', 'SouthEast');
axis([0 timeaxisplot_minute 0 80]);
xlabel('time [min]'), ylabel('temp [^\circC]');
subplot(3,1,2),plot(t_minute, plot_q_rel_dh_minute);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');
subplot(3,1,3), plot(t_minute, plot_theta_6_minute);
axis([0 timeaxisplot_minute -8 0]);
xlabel('time [min]'), ylabel('\theta_{6} [^\circC]');

figure(7);
plot(t_minute, plot_theta_ref_conv, t_minute, plot_theta_minute_conv);
legend('\theta^{conv}','\theta^{conv}_{ref}');
axis([0 timeaxisplot_minute 30 80]);
xlabel('time [min]'), ylabel('temp [^\circC]');

run night2day_plots
run day2night_plots

%%Energy 
figure(16);
plot(t_minute, plot_available_energy/1000, t_minute, plot_used_energy_mvarmeveksler/1000);
legend('Available energy', 'Used energy');
axis([0 timeaxisplot_minute 15 250]);
xlabel('time [min]'), ylabel('Energy [kW]');

savefile_conv = 'used_energy_conv';
save (savefile_conv, 'plot_used_energy_mvarmeveksler');
savefile_conv_2 = 'available_energy_conv';
save (savefile_conv_2, 'plot_available_energy');

energy_efficiency_conv = sum(plot_used_energy_mvarmeveksler(2:5760))/sum(plot_available_energy(2:5760));
potential_improvement =  (sum(plot_available_energy(2:5760))-sum(plot_available_energy_mpc(2:5760)))/sum(plot_available_energy(2:5760));
consumption_improvement =  (sum(plot_used_energy_mvarmeveksler(2:5760))-sum(plot_used_energy_mpc(2:5760)))/sum(plot_used_energy_mvarmeveksler(2:5760));

%%Disturbances
figure(17);
subplot(9,1,1), plot(t_minute, plot_w_people_A)
legend('w_{peopleA}');
subplot(9,1,2), plot(t_minute, plot_w_equip_A)
legend('w_{equipA}');
subplot(9,1,3), plot(t_minute, plot_w_lights_A)
legend('w_{lightsA}');
subplot(9,1,4), plot(t_minute, plot_w_people_B)
legend('w_{peopleB}');
subplot(9,1,5), plot(t_minute, plot_w_equip_B)
legend('w_{equipB}');
subplot(9,1,6), plot(t_minute, plot_w_lights_B)
legend('w_{lightsB}');
subplot(9,1,7), plot(t_minute, plot_w_people_C)
legend('w_{peopleC}');
subplot(9,1,8), plot(t_minute, plot_w_equip_C)
legend('w_{equipC}');
subplot(9,1,9), plot(t_minute, plot_w_lights_C)
legend('w_{lightsC}');
