%%Run the system with an MPC control scheme
%By Jonas Magnussen (2011)
clear all;
clc;
warning off;

run linearize_system
run init_values
run mpc_spec
sim building_model_mpc

%PLOT
%Temperatures
plot_theta_minute = zeros(timeaxisplot_minute,1);
plot_theta_2A_minute = zeros(timeaxisplot_minute,1);
plot_theta_2B_minute = zeros(timeaxisplot_minute,1);
plot_theta_2C_minute = zeros(timeaxisplot_minute,1);
plot_theta_4A_minute = zeros(timeaxisplot_minute,1);
plot_theta_4B_minute = zeros(timeaxisplot_minute,1);
plot_theta_4C_minute = zeros(timeaxisplot_minute,1);
plot_theta_6_minute = zeros(timeaxisplot_minute,1);
plot_theta_7_minute = zeros(timeaxisplot_minute,1);
plot_q_rel_minute = zeros(timeaxisplot_minute,1);
plot_q_rel_dh_minute = zeros(timeaxisplot_minute,1);
plot_theta_return_minute = zeros(timeaxisplot_minute,1);

plot_valve_t4A = zeros(timeaxisplot_minute,1);
plot_valve_t4B = zeros(timeaxisplot_minute,1);
plot_valve_t4C = zeros(timeaxisplot_minute,1);

%Energy
plot_used_energy_mpc = zeros(timeaxisplot_minute,1);
plot_available_energy_mpc = zeros(timeaxisplot_minute,1);

%wall temperatures
plot_t36A = zeros(timeaxisplot_minute,1);
plot_t3CA = zeros(timeaxisplot_minute,1);
plot_t36B = zeros(timeaxisplot_minute,1);
plot_t3CB = zeros(timeaxisplot_minute,1);
plot_t36C = zeros(timeaxisplot_minute,1);
plot_t3AC = zeros(timeaxisplot_minute,1);
plot_t3BC = zeros(timeaxisplot_minute,1);
plot_H_aa = zeros(timeaxisplot_minute,1);
plot_H_wa = zeros(timeaxisplot_minute,1);
plot_H_ww = zeros(timeaxisplot_minute,1);
plot_H_aw = zeros(timeaxisplot_minute,1);

%Estimates
x_kalman = zeros(timeaxisplot_minute,17);

estimated_temp_A = zeros(timeaxisplot_minute,1);
estimated_temp_B = zeros(timeaxisplot_minute,1);
estimated_temp_C = zeros(timeaxisplot_minute,1);
estimated_temp_vent = zeros(timeaxisplot_minute,1);

plot_theta_ref_mpc = zeros(timeaxisplot_minute,1);

plot_theta_ref_conv = zeros(timeaxisplot_minute,1);
for i = 0:length(plot_theta_2A_minute) - 1
    %Temperatures
    plot_theta_minute(i+1) = theta(1+6*i);
    plot_theta_2A_minute(i+1) = theta_2A(1+6*i);
    plot_theta_2B_minute(i+1) = theta_2B(1+6*i);
    plot_theta_2C_minute(i+1) = theta_2C(1+6*i);
    plot_theta_4A_minute(i+1) = theta_4A(1+6*i);
    plot_theta_4B_minute(i+1) = theta_4B(1+6*i);
    plot_theta_4C_minute(i+1) = theta_4C(1+6*i);
    plot_theta_6_minute(i+1) = theta_6(1+6*i);
    plot_theta_7_minute(i+1) = theta_7(1+6*i);
    plot_q_rel_minute(i+1) = q_rel(1+6*i);
    plot_q_rel_dh_minute(i+1) = q_rel_dh(1+6*i);
    plot_theta_return_minute(i+1) = theta_return(1+6*i);
    
    %Valve radiators
    plot_valve_t4A(i+1) = alpha_A(1 + 6*i,1);
    plot_valve_t4B(i+1) = alpha_B(1 + 6*i,1);
    plot_valve_t4C(i+1) = alpha_C(1 + 6*i,1);
    
    %Energy
    plot_used_energy_mpc(i+1) = (plot_theta_minute(i+1) -  plot_theta_return_minute(i+1))*calculate_energy;
    plot_available_energy_mpc(i+1) = plot_theta_minute(i+1)*calculate_energy;
     
    %Kalman estimates
    x_kalman(i+1, 1) = x_hat_kalman(1 + 6*i, 1);
    x_kalman(i+1, 2) = x_hat_kalman(1 + 6*i, 2);
    x_kalman(i+1, 3) = x_hat_kalman(1 + 6*i, 3);
    x_kalman(i+1, 4) = x_hat_kalman(1 + 6*i, 4);
    x_kalman(i+1, 5) = x_hat_kalman(1 + 6*i, 5);
    x_kalman(i+1, 6) = x_hat_kalman(1 + 6*i, 6);
    x_kalman(i+1, 7) = x_hat_kalman(1 + 6*i, 7);
    x_kalman(i+1, 8) = x_hat_kalman(1 + 6*i, 8);
    x_kalman(i+1, 9) = x_hat_kalman(1 + 6*i, 9);
    x_kalman(i+1, 10) = x_hat_kalman(1 + 6*i, 10);
    x_kalman(i+1, 11) = x_hat_kalman(1 + 6*i, 11);
    x_kalman(i+1, 12) = x_hat_kalman(1 + 6*i, 12);
    x_kalman(i+1, 13) = x_hat_kalman(1 + 6*i, 13);
    x_kalman(i+1, 14) = x_hat_kalman(1 + 6*i, 14);
    x_kalman(i+1, 15) = x_hat_kalman(1 + 6*i, 15);
    x_kalman(i+1, 16) = x_hat_kalman(1 + 6*i, 16);
    x_kalman(i+1, 17) = x_hat_kalman(1 + 6*i, 17);
    
    %Model-state values
    plot_t36A(i+1) = t_36A(1 + 6*i,1);
    plot_t3CA(i+1) = t_3CA(1 + 6*i,1);
    plot_t36B(i+1) = t_36B(1 + 6*i,1);
    plot_t3CB(i+1) = t_3CB(1 + 6*i,1);
    plot_t36C(i+1) = t_36C(1 + 6*i,1);
    plot_t3AC(i+1) = t_3AC(1 + 6*i,1);
    plot_t3BC(i+1) = t_3BC(1 + 6*i,1);
    plot_H_ww(i+1) = H_ww(1 + 6*i,1);
    plot_H_wa(i+1) = H_wa(1 + 6*i,1);
    plot_H_aw(i+1) = H_aw(1 + 6*i,1);
    plot_H_aa(i+1) = H_aa(1 + 6*i,1);
    
    estimated_temp_A(i+1) = yhat(1 + 6*i,1);
    estimated_temp_B(i+1) = yhat(1 + 6*i,2);
    estimated_temp_C(i+1) = yhat(1 + 6*i,3);
    estimated_temp_vent(i+1) = yhat(1 + 6*i,4);
    
    %MPC input
    plot_theta_ref_mpc(i+1) = u_mpc(1 + 6*i,1);
end

%Plot
%Indoor, radiator, water, ventilation and outdoor temperatures (Room A)
figure(1);
subplot(3,1,1), plot(t_minute, plot_theta_2A_minute);
axis([0 timeaxisplot_minute 16 22]);
xlabel('time [min]'), ylabel('\theta_{2A} [^\circC]');
subplot(3,1,2), plot(t_minute, plot_theta_4A_minute, t_minute, plot_theta_minute);
legend('\theta_{4A}', '\theta','Orientation', 'horizontal', 'Location', 'SouthEast');
axis([0 timeaxisplot_minute 17 85]);
xlabel('time [min]'), ylabel('temp [^\circC]');
subplot(3,1,3), plot(t_minute, plot_valve_t4A);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');
 
%Indoor, radiator, water, ventilation and outdoor temperatures (Room B)
figure(2);
subplot(3,1,1), plot(t_minute, plot_theta_2B_minute);
axis([0 timeaxisplot_minute 16 22]);
xlabel('time [min]'), ylabel('\theta_{2B} [^\circC]');
subplot(3,1,2), plot(t_minute, plot_theta_4B_minute, t_minute, plot_theta_minute);
legend('\theta_{4B}', '\theta','Orientation', 'horizontal', 'Location', 'SouthEast');
axis([0 timeaxisplot_minute 17 85]);
xlabel('time [min]'), ylabel('temp [^\circC]');
subplot(3,1,3), plot(t_minute, plot_valve_t4B);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');

%Indoor, radiator, water, ventilation and outdoor temperatures (Room C)
figure(3);
subplot(3,1,1), plot(t_minute, plot_theta_2C_minute);
axis([0 timeaxisplot_minute 16 22]);
xlabel('time [min]'), ylabel('\theta_{2C} [^\circC]');
subplot(3,1,2), plot(t_minute, plot_theta_4C_minute, t_minute, plot_theta_minute);
legend('\theta_{4C}', '\theta','Orientation', 'horizontal', 'Location', 'SouthEast');
axis([0 timeaxisplot_minute 17 85]);
xlabel('time [min]'), ylabel('temp [^\circC]');
subplot(3,1,3), plot(t_minute, plot_valve_t4C);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');

%Ventilation, valve, outdoor temperature
figure(4);
subplot(3,1,1), plot(t_minute, plot_theta_7_minute);
axis([0 timeaxisplot_minute 14 23]);
xlabel('time [min]'), ylabel('\theta_{7} [^\circC]');
subplot(3,1,2), plot(t_minute, plot_q_rel_minute);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');
subplot(3,1,3), plot(t_minute, plot_theta_6_minute);
axis([0 timeaxisplot_minute -8 0]);
xlabel('time [min]'), ylabel('\theta_{6} [^\circC]');

figure(5);
subplot(3,1,1),plot(t_minute, plot_theta_minute, t_minute, plot_theta_return_minute);
legend('\theta','\theta_{fb}');
axis([0 timeaxisplot_minute 0 80]);
xlabel('time [min]'), ylabel('temp [^\circC]');
subplot(3,1,2),plot(t_minute, plot_q_rel_dh_minute);
axis([0 timeaxisplot_minute 0 1]);
xlabel('time [min]'), ylabel('Valve opening');
subplot(3,1,3), plot(t_minute, plot_theta_6_minute);
axis([0 timeaxisplot_minute -8 0]);
xlabel('time [min]'), ylabel('\theta_6 [^\circC]');

figure(6);
plot(t_minute, plot_theta_ref_mpc, t_minute, plot_theta_minute);
legend('\theta^{MPC}_{ref}', '\theta^{MPC}');
axis([0 timeaxisplot_minute 30 81]);
xlabel('time [min]'), ylabel('temp [^\circC]');

figure(7);
plot(t_minute, plot_theta_6_minute);
axis([0 timeaxisplot_minute -8 0]);
xlabel('time [min]'), ylabel('\theta_{6} [^\circC]');

%% Estimates

figure(8);
subplot(4,2,1),plot(t_minute, plot_theta_2A_minute, t_minute, estimated_temp_A)
axis([0 timeaxisplot_minute 16 22]);
xlabel('time [min]'), ylabel('\theta_{2A} [^\circC]');
legend('Model', 'Kalman estimate');
subplot(4,2,2),plot(t_minute, plot_theta_2B_minute, t_minute, estimated_temp_B)
axis([0 timeaxisplot_minute 16 22]);
xlabel('time [min]'), ylabel('\theta_{2B} [^\circC]');
subplot(4,2,3),plot(t_minute, plot_theta_2C_minute, t_minute, estimated_temp_C)
axis([0 timeaxisplot_minute 16 22]);
xlabel('time [min]'), ylabel('\theta_{2C} [^\circC]');
subplot(4,2,4),plot(t_minute, plot_H_aa, t_minute, C_d(4,4)*x_kalman(:,4))
axis([0 timeaxisplot_minute -8 0]);
xlabel('time [min]'), ylabel('H_{aa} [^\circC]');
subplot(4,2,5),plot(t_minute, plot_H_wa, t_minute, C_d(4,5)*x_kalman(:, 5))
axis([0 timeaxisplot_minute 14 29]);
xlabel('time [min]'), ylabel('H_{wa} [^\circC]');
subplot(4,2,6),plot(t_minute, plot_t36A, t_minute, x_kalman(:, 6)/T_1A)
xlabel('time [min]'), ylabel('\theta_{36A} [^\circC]');
subplot(4,2,7),plot(t_minute, plot_theta_4A_minute, t_minute, x_kalman(:, 7))
axis([0 timeaxisplot_minute 10 53]);
xlabel('time [min]'), ylabel('\theta_{4A} [^\circC]');
subplot(4,2,8),plot(t_minute, plot_t3CA, t_minute, x_kalman(:, 8)/T_3A)
axis([0 timeaxisplot_minute 15 23]);
xlabel('time [min]'), ylabel('\theta_{3CA} [^\circC]');

figure(9);
subplot(5,2,1),plot(t_minute, plot_t3AC, t_minute, x_kalman(:, 9)/T_3C)
axis([0 timeaxisplot_minute 15 21]);
xlabel('time [min]'), ylabel('\theta_{3AC} [^\circC]');
legend('Model', 'Kalman estimate');
subplot(5,2,2),plot(t_minute, plot_t36B, t_minute, x_kalman(:, 10)/T_1B)
xlabel('time [min]'), ylabel('\theta_{36B} [^\circC]');
subplot(5,2,3),plot(t_minute, plot_theta_4B_minute, t_minute, x_kalman(:, 11))
axis([0 timeaxisplot_minute 12 65]);
xlabel('time [min]'), ylabel('\theta_{4B} [^\circC]');
subplot(5,2,4),plot(t_minute, plot_t3CB, t_minute, x_kalman(:, 12)/T_3B)
axis([0 timeaxisplot_minute 15 22]);
xlabel('time [min]'), ylabel('\theta_{3CB} [^\circC]');
subplot(5,2,5),plot(t_minute, plot_t3BC, t_minute, x_kalman(:, 13)/T_4C)
axis([0 timeaxisplot_minute 15 22]);
xlabel('time [min]'), ylabel('\theta_{3BC} [^\circC]');
subplot(5,2,6),plot(t_minute, plot_t36C, t_minute, x_kalman(:, 14)/T_1C)
axis([0 timeaxisplot_minute 15 16]);
xlabel('time [min]'), ylabel('\theta_{36C} [^\circC]');
subplot(5,2,7),plot(t_minute, plot_theta_4C_minute, t_minute, x_kalman(:, 15))
axis([0 timeaxisplot_minute 12 65]);
xlabel('time [min]'), ylabel('\theta_{4C} [^\circC]');
subplot(5,2,8),plot(t_minute, plot_H_aw, t_minute, K_aw*x_kalman(:, 16)/T_batt)
axis([0 timeaxisplot_minute -5 -2]);
xlabel('time [min]'), ylabel('H_{aw} [^\circC]');
subplot(5,2,9),plot(t_minute, plot_H_ww, t_minute, K_ww*x_kalman(:, 17)/T_batt)
axis([0 timeaxisplot_minute 9 20]);
xlabel('time [min]'), ylabel('H_{ww} [^\circC]');

run plot_night2day_mpc
run plot_day2night_mpc

%% Energy 
figure(19);
plot(t_minute, plot_available_energy_mpc/1000, t_minute, plot_used_energy_mpc/1000);
legend('Available energy', 'Used energy')
axis([0 timeaxisplot_minute 15 260]);
xlabel('time [min]'), ylabel('Energy [kW]');

figure(20)
subplot(2,2,1), plot(T1,Y1(:,1),T2,Y_a);
legend('\theta_{2A} model ', '\theta_{2A} linmod', 'Location', 'NorthWest')
xlabel('time [s]');
ylabel('temp [^\circ C]');
axis([0 9e+005 15.5 17.5])
subplot(2,2,2),plot(T1,Y1(:,2),T2,Y_b);
legend('\theta_{2B} model ', '\theta_{2B} linmod', 'Location', 'NorthWest')
xlabel('time [s]');
ylabel('temp [^\circ C]');
axis([0 9e+005 15.5 17.5])
subplot(2,2,3),plot(T1,Y1(:,3),T2,Y_c);
legend('\theta_{2C} model ', '\theta_{2C} linmod', 'Location', 'NorthWest')
xlabel('time [s]');
ylabel('temp [^\circ C]');
axis([0 9e+005 14 18])
subplot(2,2,4),plot(T1,Y1(:,4),T2,Y_v);
legend('\theta_7 model ', '\theta_7 linmod', 'Location', 'NorthWest')
xlabel('time [s]');
ylabel('temp [^\circ C]');
axis([0 9e+005 14 25])
