%Weather generator
%By Jonas Magnussen (2011)
function theta_6 = temperature(second)

weather_forecast = [-6,-6,-7,-7,-7,-7,-7,-7,-7,-7,-7,-7,-7,-7,-7,-7,-6,-6,-6,-5,...
                    -4,-4,-4,-4,-5,-5,-5,-6,-6,-6,-6,-6,-6,-6,-7,-7,-7,-7,-6,-6,...
                    -6,-5,-5,-4,-3,-3,-3,-3,-4,-4,-4,-4,-4,-4,-5,-5,-5,-5,-4,-4,...
                    -4,-4,-4,-4,-4,-4,-3,-3,-2,-2,-2,-2,-3,-4,-4,-4,-4,-4,-5,-5,...
                    -5,-5,-6,-6,-6,-7,-7,-7,-7,-6,-4,-3,-2,-1,-1,-1,-2,-2,-3,-4,...
                    -4,-4,-4,-5,-5,-6,-6];
                      
                      
hour = 3600;

k = (second - mod(second, hour))/hour;

e_1 = mod(k+1, length(weather_forecast) - 1) + 1;
e_2 = mod(e_1, length(weather_forecast));

if e_2 == e_1
    e_2 = e_1 + 1;
end

temp_1 = weather_forecast(e_1);
temp_2 = weather_forecast(e_2);

delta_T = temp_2 - temp_1;

T = temp_1 + delta_T*(mod(second, hour)/hour);

theta_6 = T;                  

